<?php
/*
Plugin Name: BuzzVolume Twitter Integration
Plugin URI: http://buzzvolume.com/
Description: O plugin do BuzzVolume facilita a integração do seu site e blog com o Twitter. O plugin permite a inserção de 3 elementos: Botão de Retweet, para facilitar o compartilhamento do seu conteúdo no Twitter, Widget Top Posts, para melhorar a experiência de navegação do usuário recomendando páginas "quentes" do site e o Widget com Tweets Recentes que exibe os comentários que fizeram no Twitter sobre a página.
Version: 1.9
Author: BuzzVolume
Author URI: http://buzzvolume.com/
*/

function buzz_options() {
	add_options_page('BuzzVolume', 'BuzzVolume', 8, '_BUZZVOLUME_', 'buzz_options_page');
}

// widget com posts mais tweetado do dominio
function buzzvolume_top_posts() {
	if (get_option('buzz_top_posts') == 1) {
		if (preg_match("/(localhost:|localhost\/\~)/", get_bloginfo('url'))) {
			echo "<script type='text/javascript' src='http://localhost:4567/widgets/popular_pages/buzztop_posts.js'></script>";
		} else {
			echo "<script type='text/javascript' src='http://buzzvolume.com/widgets/popular_pages/buzztop_posts.js'></script>";
		}
	}
}

// widget com ultimos tweets sobre a URL
function buzzvolume_retweets() {
	if (get_option('buzz_retweets') == 1) {
	    global $post;
	    $url = '';
	    if (get_post_status($post->ID) == 'publish') {   
	        $url = get_permalink();
	    } 
	    echo "<script type='text/javascript'>buzzvolume_url = '". urlencode($url) ."';</script>";
		if (preg_match("/(localhost:|localhost\/\~)/", get_bloginfo('url'))) {
			echo "<script type='text/javascript' src='http://localhost:4567/widgets/recent_tweets/buzzretweets.js'></script>";	
		} else {
			echo "<script type='text/javascript' src='http://buzzvolume.com/widgets/recent_tweets/buzzretweets.js'></script>";	
		}
	}
}

// widget de retweet
function buzz_generate_button() {
    global $post;
	if (preg_match("/(localhost:|localhost\/\~)/", get_bloginfo('url'))) {
    	$url = 'http://localhost:4567/widgets/retweet/retweet.html';
	} else {
    	$url = 'http://buzzvolume.com/widgets/retweet/retweet.html';
	}
	
	$url .= '?title='. urlencode($post->post_title);
	
	if (get_post_status($post->ID) == 'publish') {   
        $url .= '&url='. urlencode(get_permalink());
    }
	
    if (get_option('buzz_version') == 'compact') {
		$width = 99;
		$height = 19;
        $url .= '&style=compact';
    } else {
		$width = 50;
		$height = 57;
	}
    if (get_option('buzz_source')) {
		$url .= '&source='. urlencode(get_option('buzz_source'));
    }
    if (get_option('buzz_background')) {
		$url .= '&background='. urlencode(get_option('buzz_background'));
    }
    if (get_option('buzz_color')) {
		$url .= '&color='. urlencode(get_option('buzz_color'));
    }
    if (get_option('buzz_x_login')) {
		$url .= '&x_login='. urlencode(get_option('buzz_x_login'));
    }
    if (get_option('buzz_x_apiKey')) {
		$url .= '&x_apiKey='. urlencode(get_option('buzz_x_apiKey'));
    }
	
    $button = '<div class="bzbutton" style="' . get_option('buzz_rss_where_style') . get_option('buzz_where_style') . get_option('buzz_style') . '">';
	$button .= '<iframe src="'. $url .'" width="'. $width .'" height="'. $height .'" frameborder="0" scrolling="no"></iframe>';
	$button .= '</div>';
	
    return $button;
}

function buzz_generate_static_button() {
	if (get_post_status($post->ID) == 'publish') {   
        $url = get_permalink();
		$title = $post->post_title;
    } 

    if (get_option('buzz_source')) {
        $msg = urlencode('RT @'. get_option('buzz_source') .' '. $title .' '. $url);
    } else {
		$msg = urlencode('RT @buzzvolume '.$title.' '. $url);
	}

	return '<div class="bzbutton" style="' . get_option('buzz_rss_where_style') . get_option('buzz_where_style') . get_option('buzz_style') . '"><a href="http://twitter.com/home/?status=' . urlencode($msg) . '"><img src="http://buzzvolume.com/button.png?url=' . urlencode($url) . '" /></a></div>';
}

function buzz_update($content) {
    global $post;
    if (get_option('buzz_display_page') == null && is_page()) {
        return $content;
    }
    
    if (get_option('buzz_display_front') == null && is_home()) {
        return $content;
    }
    
    if (is_feed()) {
		$button = buzz_generate_static_button();
		$where = 'buzz_rss_where';
    } else {
		$button = buzz_generate_button(); 
		$where = 'buzz_where'; 
	}
    
    if (get_option($where) == 'shortcode') {
		return str_replace('[buzzvolume]', $button, $content);
	} else {
        if (get_option($where) == 'beforeandafter') {
            return $button . $content . $button;
        } else if (get_option($where) == 'before') {
            return $button . $content;
        } else {	
            return $content . $button;
        }
	}
}

// Remove the filter excerpts
function buzz_remove_filter($content) {
	if (!is_feed()) {
    	remove_action('the_content', 'buzz_update');
	}
    return $content;
}

function buzz_options_page() {
?>
    <div class="wrap">
    <div class="icon32" id="icon-options-general"><br/></div><h2>Opções do BuzzVolume</h2>
	<h3>Widget de retweet</h3>
    <p>Insira o widget de retweet do BuzzVolume em cada uma das páginas do seu blog e no RSS:</p>
    <form method="post" action="options.php">
    <?php
        // New way of setting the fields, for WP 2.7 and newer
        if(function_exists('settings_fields')){
            settings_fields('buzz-options');
        } else {
            wp_nonce_field('update-options');
            ?>
            <input type="hidden" name="action" value="update" />
            <input type="hidden" name="page_options" value="buzz_where,buzz_style,buzz_background, buzz_color,buzz_version,buzz_display_page,buzz_display_front,buzz_display_rss,buzz_display_feed,buzz_source,buzz_x_login,buzz_x_apiKey" />
            <?php
        }
    ?>
        <table class="form-table">
	            <tr>
	                <th scope="row">
	                    Opções
	                </th>
	                <td>
	                    <p>
	                        <input type="checkbox" value="1" <?php if (get_option('buzz_display_page') == '1') echo 'checked="checked"'; ?> name="buzz_display_page" id="buzz_display_page" group="buzz_display"/> 
	                        <label for="buzz_display_page">Mostrar o botão nas páginas.</label>
	                    </p>
	                    <p>
	                        <input type="checkbox" value="1" <?php if (get_option('buzz_display_front') == '1') echo 'checked="checked"'; ?> name="buzz_display_front" id="buzz_display_front" group="buzz_display"/> 
	                        <label for="buzz_display_front">Mostrar o botão na primeira página (home). O botão não aparecerá caso você utilizar resumos na primeira página.</label>     
	                    </p>
	                    <p>
	                        <input type="checkbox" value="1" <?php if (get_option('buzz_display_rss') == '1') echo 'checked="checked"'; ?> name="buzz_display_rss" id="buzz_display_rss" group="buzz_display"/> 
	                        <label for="buzz_display_rss">Mostrar o botão no seu feed.</label>     
	                    </p>
	                </td>
	            </tr>
	            <tr>
	                <th scope="row">
	                    Cores:
	                </th>
	                <td>
						<div id="example" <?php if (get_option('buzz_version') == 'compact') echo 'class="twMin"'; ?>>
							<span id="tw" class="tw">186</span>
							<span id="rt">
								<a href="#" id="statuses" title="retweet this!" rel="external">retweet</a>
							</span>	
						</div>
	                	<div id="buzzcolorselect">
							<input type="hidden" id="bzbgselect" name="buzz_background" value="<?php echo get_option('buzz_background'); ?>" />
							<div id="colorSelector"><div style="background-color: #<?php echo (get_option('buzz_background') == '') ? 'd8008e' : get_option('buzz_background'); ?>">Fundo</div></div>
							<input type="hidden" id="bzcolorselect" name="buzz_color" value="<?php echo get_option('buzz_color'); ?>" />
							<div id="colorSelector2"><div style="background-color: #<?php echo (get_option('buzz_color') == '') ? 'ffffff' : get_option('buzz_color'); ?>"> Texto</div></div>
						</div>
					</td>
				</tr>
	            <tr>
	                <th scope="row">
	                    Tipo
	                </th>
	                <td>
	                    <p>
	                        <input type="radio" value="large" <?php if (get_option('buzz_version') == 'large') echo 'checked="checked"'; ?> name="buzz_version" id="buzz_version_large" group="buzz_version" onchange="changeBuzzType(0);" /> 
	                        <label for="buzz_version_large">Widget padrão</label>
	                    </p>
	                    <p>
	                        <input type="radio" value="compact" <?php if (get_option('buzz_version') == 'compact') echo 'checked="checked"'; ?> name="buzz_version" id="buzz_version_compact" group="buzz_version" onchange="changeBuzzType(1);" />
	                        <label for="buzz_version_compact">Widget compacto</label>    
	                    </p>
	                </td>
	            </tr>
            <tr>
                <th scope="row">
                    Posicionamento
                </th>
                <td>
                	<p>
                		<select name="buzz_where">
                			<option <?php if (get_option('buzz_where') == 'before') echo 'selected="selected"'; ?> value="before">Antes</option>
                			<option <?php if (get_option('buzz_where') == 'after') echo 'selected="selected"'; ?> value="after">Depois</option>  
                			<option <?php if (get_option('buzz_where') == 'beforeandafter') echo 'selected="selected"'; ?> value="beforeandafter">Antes e depois</option>  
                			<option <?php if (get_option('buzz_where') == 'shortcode') echo 'selected="selected"'; ?> value="shortcode">Atalho [buzzvolume]</option>
                		</select>
                	</p>
                	<p>
                		<select name="buzz_where_style">
                			<option <?php if (get_option('buzz_where_style') == 'float:left;margin-right:10px;') echo 'selected="selected"'; ?> value="float:left;margin-right:10px;">Esquerda</option>
                			<option <?php if (get_option('buzz_where_style') == 'float:right;margin-left:10px;') echo 'selected="selected"'; ?> value="float:right;margin-left:10px;">Direita</option>
                			<option <?php if (get_option('buzz_where_style') == '') echo 'selected="selected"'; ?> value="">Indefinido (estilize no campo 'Estilo')</option>
                		</select>
                	</p>
                </td>
            </tr>
            <tr>
                <th scope="row">
                    Posicionamento no RSS
                </th>
                <td>
                	<p>
                		<select name="buzz_rss_where">
                			<option <?php if (get_option('buzz_rss_where') == 'before') echo 'selected="selected"'; ?> value="before">Antes</option>
                			<option <?php if (get_option('buzz_rss_where') == 'after') echo 'selected="selected"'; ?> value="after">Depois</option>  
                			<option <?php if (get_option('buzz_rss_where') == 'beforeandafter') echo 'selected="selected"'; ?> value="beforeandafter">Antes e depois</option>
                			<option <?php if (get_option('buzz_where') == 'shortcode') echo 'selected="selected"'; ?> value="shortcode">Atalho [buzzvolume]</option>   
                		</select>
                	</p>
                	<p>
                		<select name="buzz_rss_where_style">
                			<option <?php if (get_option('buzz_rss_where_style') == 'float:left;margin-right:10px;') echo 'selected="selected"'; ?> value="float:left;margin-right:10px;">Esquerda</option>
                			<option <?php if (get_option('buzz_rss_where_style') == 'float:right;margin-left:10px;') echo 'selected="selected"'; ?> value="float:right;margin-left:10px;">Direita</option>
                			<option <?php if (get_option('buzz_rss_where_style') == '') echo 'selected="selected"'; ?> value="">Indefinido (estilize no campo 'Estilo')</option>
                		</select>
                	</p>
                </td>
            </tr>
            <tr>
                <th scope="row"><label for="buzz_style">Estilo</label></th>
                <td>
                    <input type="text" value="<?php echo htmlspecialchars(get_option('buzz_style')); ?>" name="buzz_style" id="buzz_style" />
                    <span class="setting-description">Adicione um estilo para o elemento que contem o botão Ex: <code>margin-top: 10px;</code></span>
                </td>
            </tr> 
            <tr>
                <th scope="row">
                    Fonte
                </th>
                <td>
                    <p>
                        RT @<input type="text" value="<?php echo get_option('buzz_source'); ?>" name="buzz_source" id="buzz_source" /> 
                        <label for="buzz_source">Altere a fonte do RT que o botão usa de RT @buzzvolume para RT @seu_nome</label>
                    </p>
                </td>
            </tr>
			<!--
            <tr>
                <th scope="row">
                    xAuth (bit.ly)<br/>
					<a href="http://bit.ly/a/your_api_key">Veja a sua no bit.ly</a>
                </th>
                <td>
                    <p>
						Login <input type="text" value="<?php echo get_option('buzz_x_login'); ?>" name="buzz_x_login" id="buzz_x_login" /> <br/>
						API Key <input type="text" value="<?php echo get_option('buzz_x_apiKey'); ?>" name="buzz_x_apiKey" id="buzz_x_apiKey" />
                    </p>
					<p>
						Use para ver estatísticas de clicks direto no bit.ly
					</p>
                </td>
            </tr>
			-->
        </table>
		<h3>Widget Top Posts</h3>
		<p>Esse widget exibe na barra lateral os 5 links mais tweetados do dominio.</p>
		<p><input type="checkbox" value="1" <?php if (get_option('buzz_top_posts') == '1') echo 'checked="checked"'; ?> name="buzz_top_posts" id="buzz_top_posts" /> Habilitar</p>
		<h3>Widget Tweets Recentes</h3>
		<p>Esse widget exibe próximo aos comentários os 5 tweets mais recentes sobre o link.</p>
		<p><input type="checkbox" value="1" <?php if (get_option('buzz_retweets') == '1') echo 'checked="checked"'; ?> name="buzz_retweets" id="buzz_retweets" /> Habilitar</p>
        <p class="submit">
            <input type="submit" name="Submit" value="<?php _e('Salvar alterações') ?>" />
        </p>
    </form>
    </div>

	<link rel="stylesheet" media="screen" type="text/css" href="<?php echo get_option('siteurl'); ?>/wp-content/plugins/buzzvolume/colorpicker.css" />
	<script type="text/javascript" src="<?php echo get_option('siteurl'); ?>/wp-content/plugins/buzzvolume/colorpicker.js"></script>
	<script type="text/javascript">
	// para onde tiver color picker do widget. no site, no wordpress...
	function changeBuzzType(type) {
		if (type == 1) {
			jQuery('#example').addClass('twMin');
		} else {
			jQuery('#example').removeClass('twMin');
		}
	}
	
	jQuery(function($) {
		$('#statuses').css('background-color', "#<?php echo (get_option('buzz_background') == '') ? 'd8008e' : get_option('buzz_background'); ?>");
		$('#statuses').css('color', "#<?php echo (get_option('buzz_color') == '') ? 'ffffff' : get_option('buzz_color'); ?>");
		
		$('#colorSelector').ColorPicker({
			color: "#<?php echo (get_option('buzz_background') == '') ? 'd8008e' : get_option('buzz_background'); ?>",
			onShow: function (colpkr) {
				$(colpkr).fadeIn(250);
				return false;
			},
			onHide: function (colpkr) {
				$(colpkr).fadeOut(250);
				return false;
			},
			onSubmit: function(t) {
				$('#colorSelector').ColorPickerHide();
				return false;
			},
			onChange: function (hsb, hex, rgb) {
				$('#colorSelector div').css('backgroundColor', '#' + hex);
				$('#statuses').css('backgroundColor', '#' + hex);
				$('#bzbgselect').val(hex);
			}
		});
		
		$('#colorSelector2').ColorPicker({
			color: "#<?php echo (get_option('buzz_color') == '') ? 'ffffff' : get_option('buzz_color'); ?>",
			onShow: function (colpkr) {
				$(colpkr).fadeIn(250);
				return false;
			},
			onHide: function (colpkr) {
				$(colpkr).fadeOut(250);
				return false;
			},
			onSubmit: function(t) {
				$('#colorSelector2').ColorPickerHide();
				return false;
			},
			onChange: function (hsb, hex, rgb) {
				$('#colorSelector2 div').css('backgroundColor', '#' + hex);
				$('#statuses').css('color', '#' + hex);
				$('#bzcolorselect').val(hex);
			}
		});
	});
	</script>
<?php
}

// On access of the admin page, register these variables (required for WP 2.7 & newer)
function buzz_init(){
    if(function_exists('register_setting')){
        register_setting('buzz-options', 'buzz_display_page');
        register_setting('buzz-options', 'buzz_display_front'); 
        register_setting('buzz-options', 'buzz_display_rss'); 
        register_setting('buzz-options', 'buzz_source', 'buzz_sanitize_username');
        register_setting('buzz-options', 'buzz_style');
        register_setting('buzz-options', 'buzz_rss_where_style');
        register_setting('buzz-options', 'buzz_where_style');
        register_setting('buzz-options', 'buzz_version');
        register_setting('buzz-options', 'buzz_where');
        register_setting('buzz-options', 'buzz_rss_where');
        register_setting('buzz-options', 'buzz_top_posts');
        register_setting('buzz-options', 'buzz_retweets');
        register_setting('buzz-options', 'buzz_background');
        register_setting('buzz-options', 'buzz_color');
        register_setting('buzz-options', 'buzz_x_login');
        register_setting('buzz-options', 'buzz_x_apiKey');
    }
}

function buzz_sanitize_username($username){
    return preg_replace('/[^A-Za-z0-9_]/','',$username);
}

// Only all the admin options if the user is an admin
if(is_admin()){
    add_action('admin_menu', 'buzz_options');
    add_action('admin_init', 'buzz_init');
}

//Set the default options when the plugin is activated
function buzz_activate(){
    add_option('buzz_where', 'before');
    add_option('buzz_rss_where', 'before');
    add_option('buzz_source');
    add_option('buzz_background');
    add_option('buzz_color');
    add_option('buzz_style', '');
    add_option('buzz_rss_where_style', 'float:left;margin-right:10px;');
    add_option('buzz_where_style', 'float:left;margin-right:10px;');
    add_option('buzz_version', 'large');
    add_option('buzz_display_page', '1');
    add_option('buzz_display_front', '1');
    add_option('buzz_display_rss', '1');
    add_option('buzz_top_posts', '0');
    add_option('buzz_retweets', '0');
    add_option('buzz_x_login');
    add_option('buzz_x_apiKey');
}

add_action('comment_form', 'buzzvolume_retweets');
add_action('wp_meta', 'buzzvolume_top_posts');

add_filter('the_content', 'buzz_update');
add_filter('get_the_excerpt', 'buzz_remove_filter', 9);

register_activation_hook( __FILE__, 'buzz_activate' );